searchNodes=[{"ref":"ExtConfigProvider.html","title":"ExtConfigProvider","type":"module","doc":"Flexible Config Provider for e.g. AWS Parameter Store/Secrets Manager Fetch your configuration at the start of the application from AWS Parameter Store or the Secrets Manager. The format of your secrets can be json/toml or any other format. There&#39;s also flexibility in how the secrets are applied to your config. Installation The package can be installed by adding aws_config_provider to your list of dependencies in mix.exs: def deps do [ {:aws_config_provider, &quot;~&gt; 1.0.0&quot;} ] end The AWS Parameter Store/Secrets Manager are packaged config providers. They need ExAws to be configured and have the right IAM permissions to work. Adding a config provider def project do [ app: :example, ... releases: [ example: [ config_providers: [{ExtConfigProvider, [path: &quot;parameter_name&quot;]}] ] ] ] end The config provider can take several options. See ExtConfigProvider.init/1 A macro can also be used to build a config provider defmodule Example.ConfigProvider do use ExtConfigProvider, parser: ExtConfigProvider.Parser.String, transformer: ExtConfigProvider.Transformer.Value, merge_strategy: ExtConfigProvider.MergeStrategy.Path, config_path: [:app, :secret] end You can add this config provider in the usual fashion: releases: [ example: [ config_providers: [{Example.ConfigProvider, [path: &quot;parameter_name&quot;]}] ] ] Inspired by https://github.com/christopherlai/secrets_manager_provider Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/aws_config_provider."},{"ref":"ExtConfigProvider.html#init/1","title":"ExtConfigProvider.init/1","type":"function","doc":"Accepts list of opts: :path -- (required) the key of the parameter. If supplied a tuple {:env, &quot;env&quot;}, the specified env var will be used as the path. :parser -- how to parse the retrieved parameter, defaults to Jason :transformer -- transform the parsed value to a configuration, defaults to ExtConfigProvider.Transformer.Default :merge_strategy -- how to apply the configuration to the existing configuration, defaults to ExtConfigProvider.MergeStrategy.Default :client -- Which client to use to get the parameter, defaults to ExtConfigProvider.Client.ParameterStore :client_opts -- keyword list to pass to the client to override e.g. region"},{"ref":"ExtConfigProvider.Client.html","title":"ExtConfigProvider.Client","type":"behaviour","doc":"Behaviour for the AWS Client Expects a config_key, which will be the key the parameter is stored under. And a list of config_overrides to override the configuration for the AWS client."},{"ref":"ExtConfigProvider.Client.html#c:get_config/2","title":"ExtConfigProvider.Client.get_config/2","type":"callback","doc":""},{"ref":"ExtConfigProvider.Client.AwsParameterStore.html","title":"ExtConfigProvider.Client.AwsParameterStore","type":"module","doc":"The ParameterStore Client queries the AWS SSM Parameter Store Requires the ExAws and ExAws.SSM packages. The profile making the api call needs ssm:GetParameter permission on the resource."},{"ref":"ExtConfigProvider.Client.AwsParameterStore.html#get_config/3","title":"ExtConfigProvider.Client.AwsParameterStore.get_config/3","type":"function","doc":"Get config for given key. config_overrides are passed on to ExAws.request/2. Example AwsParameterStore.get_config(&quot;app/prod&quot;) AwsParameterStore.get_config(&quot;app/prod&quot;, [region: &quot;eu-west-1&quot;])"},{"ref":"ExtConfigProvider.Client.AwsSecretsManager.html","title":"ExtConfigProvider.Client.AwsSecretsManager","type":"module","doc":"The SecretsManager Client queries the AWS Secrets Manager Requires the ExAws and ExAws.SecretsManager packages. The profile making the api call needs secretsmanager:GetSecretValue permission on the resource."},{"ref":"ExtConfigProvider.Client.AwsSecretsManager.html#get_config/3","title":"ExtConfigProvider.Client.AwsSecretsManager.get_config/3","type":"function","doc":"Get config for given key. config_overrides are passed on to ExAws.request/2. Example AwsSecretsManager.get_config(&quot;app/prod&quot;) AwsSecretsManager.get_config(&quot;app/prod&quot;, [region: &quot;eu-west-1&quot;])"},{"ref":"ExtConfigProvider.MergeStrategy.html","title":"ExtConfigProvider.MergeStrategy","type":"behaviour","doc":"Strategy behaviour. Determines how to merge the retrieved config with the existing config in your application."},{"ref":"ExtConfigProvider.MergeStrategy.html#c:apply/3","title":"ExtConfigProvider.MergeStrategy.apply/3","type":"callback","doc":""},{"ref":"ExtConfigProvider.MergeStrategy.Default.html","title":"ExtConfigProvider.MergeStrategy.Default","type":"module","doc":"Strategy to merge the retrieved secrets as a keyword list into the current configuration."},{"ref":"ExtConfigProvider.MergeStrategy.Default.html#apply/3","title":"ExtConfigProvider.MergeStrategy.Default.apply/3","type":"function","doc":"Example iex&gt; existing_config = [toplevel: [a: 1]] iex&gt; new_config = [toplevel: [&quot;Some.Module&quot;: &quot;config&quot;]] iex&gt; ExtConfigProvider.MergeStrategy.Default.apply(new_config, existing_config, []) [toplevel: [a: 1, &quot;Some.Module&quot;: &quot;config&quot;]]"},{"ref":"ExtConfigProvider.MergeStrategy.Path.html","title":"ExtConfigProvider.MergeStrategy.Path","type":"module","doc":"Strategy to merge the retrieved secrets into a specific key in the config"},{"ref":"ExtConfigProvider.MergeStrategy.Path.html#apply/3","title":"ExtConfigProvider.MergeStrategy.Path.apply/3","type":"function","doc":"Merge the retrieved parameter into a specific configuration key Example iex&gt; existing_config = [toplevel: [&quot;Example.Repo&quot;: 1, b: 2]] iex&gt; new_config = &quot;some value&quot; iex&gt; key = [:toplevel, :&quot;Example.Repo&quot;] iex&gt; ExtConfigProvider.MergeStrategy.Path.apply(new_config, existing_config, config_path: key) [toplevel: [&quot;Example.Repo&quot;: &quot;some value&quot;, b: 2]]"},{"ref":"ExtConfigProvider.Parser.html","title":"ExtConfigProvider.Parser","type":"behaviour","doc":"Behaviour to take the parameter and convert it. E.g. convert json, toml or plain strings to something for your application to deal with."},{"ref":"ExtConfigProvider.Parser.html#c:decode!/1","title":"ExtConfigProvider.Parser.decode!/1","type":"callback","doc":""},{"ref":"ExtConfigProvider.Parser.String.html","title":"ExtConfigProvider.Parser.String","type":"module","doc":"Simple parser that accepts the value of the config and returns it"},{"ref":"ExtConfigProvider.Parser.String.html#decode!/1","title":"ExtConfigProvider.Parser.String.decode!/1","type":"function","doc":""},{"ref":"ExtConfigProvider.Transformer.html","title":"ExtConfigProvider.Transformer","type":"behaviour","doc":"Behaviour to transform the result of the decoded config into a datastructure suitable for the merge strategy to work with."},{"ref":"ExtConfigProvider.Transformer.html#c:apply/1","title":"ExtConfigProvider.Transformer.apply/1","type":"callback","doc":""},{"ref":"ExtConfigProvider.Transformer.Default.html","title":"ExtConfigProvider.Transformer.Default","type":"module","doc":"Takes a map and transforms it to a keyword list suitable for elixir configuration. When keys in a map start with capital letters, they are assumed to refer to Elixir modules."},{"ref":"ExtConfigProvider.Transformer.Default.html#apply/1","title":"ExtConfigProvider.Transformer.Default.apply/1","type":"function","doc":"Example iex&gt; ExtConfigProvider.Transformer.Default.apply(%{&quot;Example.Repo&quot; =&gt; %{&quot;url&quot; =&gt; &quot;some_url&quot;}}) [{Example.Repo, [url: &quot;some_url&quot;]}]"},{"ref":"ExtConfigProvider.Transformer.Value.html","title":"ExtConfigProvider.Transformer.Value","type":"module","doc":"Takes a value and returns it. Useful for when the value of in the store needs to be used directly"},{"ref":"ExtConfigProvider.Transformer.Value.html#apply/1","title":"ExtConfigProvider.Transformer.Value.apply/1","type":"function","doc":"Callback implementation for ExtConfigProvider.Transformer.apply/1."}]